SystemOrganization addCategory: #'PLP-TP3'!

TestCase subclass: #TransformadorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:39'!
testTransBloque

	| trans5 unBloque unaColeccionOrdenada |
	trans5 := self transformador5 .
	unaColeccionOrdenada := OrderedCollection new.
	unBloque := [ unaColeccionOrdenada add: 0 ].
	
	(trans5 transformar: unBloque) value.
	self assert: ( unaColeccionOrdenada size = 3 ).! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'Nicolas 11/9/2013 22:18'!
testTransCaracter

	| trans2 trans3 |
	trans2 := self transformador2 .
	trans3 := self transformador3 .
	
	self assert: ( (trans2 transform: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans2 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans3 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans3 transformar: 'patoloco') = 'patoloco' ).
! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'Nicolas 11/9/2013 19:50'!
testTransCondicion

	| trans8 trans9 
	unStringImpar otroStringImpar unStringPar otroStringPar 
	unBloquePar unBloqueImpar unaColeccionOrdenada unNuevoBloque |
	
	trans8 := self transformador8 .
	trans9 := self transformador9 .
	
	unStringImpar := 'bab'.
	unStringPar := 'aa'.
	otroStringImpar := 'aaa'.
	otroStringPar := 'bb'.
	
	self assert: ( (trans8 transformar: unStringPar) = 'bb' ).
	self assert: ( (trans8 transformar: unStringImpar) = 'aaa' ).
	self assert: ( (trans8 transformar: otroStringPar) = otroStringPar ).
	self assert: ( (trans8 transformar: otroStringImpar ) = otroStringImpar ).
	
	unaColeccionOrdenada := OrderedCollection new.
	unBloquePar := [ unaColeccionOrdenada add:0. ^4 ].
	unBloqueImpar := [ unaColeccionOrdenada add:0. ^3 ].
	
	unNuevoBloque := trans9 transformar: unBloquePar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 3).
	
	unNuevoBloque := trans9 transformar: unBloqueImpar.
	unaColeccionOrdenada := OrderedCollection new.
	unNuevoBloque value.
	self assert: (unaColeccionOrdenada size = 1).
! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:04'!
testTransIdentidad

| unTransformadorIdentidad |
unTransformadorIdentidad := self transformador1 .
self assert: ( unTransformadorIdentidad transformar: self == self ).! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'ManuelGimenez 11/5/2013 00:01'!
testTransSecuencial

	| trans6 trans7 |
	trans6 := self transformador6 .
	trans7 := self transformador7 .
	
	self assert: ( (trans6 transformar: 'patoloco') = 'patoloco' ).
	self assert: ( (trans6 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans6 transformar: 'elosodebimbo') = 'elosodeaimao' ).
	self assert: ( (trans7 transformar: 'patoloco') = 'pbtoloco' ).
	self assert: ( (trans7 transformar: 'monoloco') = 'monoloco' ).! !

!TransformadorTest methodsFor: 'testsCompuestos' stamp: 'ValeriaTiffenberg 11/9/2013 20:15'!
testTransSecuencial2

	| trans10 |
	trans10 := TransSecuencial transformador1: (TransSubstring original: 'buu' transformado: 'pepe') transformador2: (TransSubstring original: 'pepe' transformado: 'foo').
	
	self assert: ( (trans10 transformar: 'buu') = 'foo' ).
	self assert: ( (trans10 transformar: 'pepe') = 'foo').
	self assert: ( (trans10 transformar: 'xyz') = 'xyz').! !

!TransformadorTest methodsFor: 'testsBasicos' stamp: 'ManuelGimenez 10/30/2013 00:22'!
testTransSubstring

	| trans4 |
	trans4 := self transformador4 .
	
	self assert: ( (trans4 transformar: 'monoloco') = 'monoloco' ).
	self assert: ( (trans4 transformar: 'buu') = 'md' ).
	self assert: ( (trans4 transformar: 'monobuuloco') = 'monomdloco' ).! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Nicolas 11/9/2013 17:40'!
transformador1
	"Debe retornar el transformador especificado en el enunciado"
	^TransIdentidad new.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Nicolas 11/9/2013 18:08'!
transformador2
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter original: 'a' transformado: 'b'.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Nicolas 11/9/2013 18:08'!
transformador3
	"Debe retornar el transformador especificado en el enunciado"
	^TransCaracter original: 'b' transformado: 'a'.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Nicolas 11/9/2013 18:26'!
transformador4
	"Debe retornar el transformador especificado en el enunciado"
	^TransSubstring original: 'buu' transformado: 'md'.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Gabriel 11/9/2013 18:33'!
transformador5
	"Debe retornar el transformador especificado en el enunciado"
	^TransBloque n: 3.! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Gabriel 11/9/2013 20:23'!
transformador6
	"Debe retornar el transformador especificado en el enunciado"
	^ TransSecuencial transformador1: (self transformador2 ) transformador2: (self transformador3).! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Gabriel 11/9/2013 20:21'!
transformador7
	"Debe retornar el transformador especificado en el enunciado"
	^ TransSecuencial transformador1: (self transformador6) transformador2: (self transformador2 ).! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Nicolas 11/9/2013 20:10'!
transformador8
	"Debe retornar el transformador especificado en el enunciado"
	| trans1 trans2 cond |
	trans1 := self transformador2.
	trans2 := self transformador3.
	cond := [ :obj | (obj size) % 2 = 0 ].
	^ TransCondicion transformador1: trans1 transformador2: trans2 condicion: cond .! !

!TransformadorTest methodsFor: 'transformadoresDefinidos' stamp: 'Nicolas 11/9/2013 20:12'!
transformador9
	"Debe retornar el transformador especificado en el enunciado"
	| trans1 trans2 cond |
	trans1 := self transformador5.
	trans2 := self transformador1.
	cond := [ :obj | (obj value) % 2 = 0 ].
	^ TransCondicion transformador1: trans1 transformador2: trans2 condicion: cond .! !

Object subclass: #Arreglador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!Arreglador class methodsFor: 'as yet unclassified' stamp: 'ValeriaTiffenberg 11/9/2013 22:23'!
renombrar: selectorOriginal por: nuevoSelector
	"Debe modificar la implementacion para reflejar complacer el ultimo capricho del arquitecto"
	Transformador  compile: nuevoSelector , '
	^self ', selectorOriginal , '.' .! !

Object subclass: #Transformador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

Transformador subclass: #TransBloque
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransBloque class methodsFor: 'as yet unclassified' stamp: 'Gabriel 11/9/2013 18:46'!
n: aNumber 

|a|
a := TransBloque  new.
a inicializar: aNumber.
^a.! !

!TransBloque methodsFor: 'as yet unclassified' stamp: 'Gabriel 11/9/2013 18:47'!
inicializar: aNumber

	n := aNumber.! !

!TransBloque methodsFor: 'as yet unclassified' stamp: 'Gabriel 11/9/2013 19:33'!
transformar: aBlock
	"comment stating purpose of message"
	|newBlock|
	1 to: n do: [ :i | newBlock := aBlock value].
	^ newBlock .! !

Transformador subclass: #TransCaracter
	instanceVariableNames: 'original transformado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransCaracter class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:23'!
original: aChar transformado:bChar 

|a|
a := TransCaracter new.
a inicializar: aChar con: bChar.
^a.! !

!TransCaracter methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:22'!
inicializar: aChar con: bChar

	original := aChar.
	transformado := bChar.! !

!TransCaracter methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:16'!
transformar: aObject 

	   ^ aObject copyReplaceAll: original with: transformado.! !

Transformador subclass: #TransCompuesto
	instanceVariableNames: 'trans1 trans2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

TransCompuesto subclass: #TransAleatorio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransAleatorio class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:35'!
transformador1: aTrans1 transformador2: aTrans2

|a|
a := TransAleatorio new.
a inicializar: aTrans1 con: aTrans2.
^a.! !

!TransAleatorio methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 19:01'!
transformar: aObject 

	| opt |
	opt := (1 to: 2) atRandom. 
	^ opt = 1
		ifTrue: [ trans1 transformar: aObject ] 
		ifFalse: [ trans2 transformar: aObject ].! !

!TransCompuesto methodsFor: 'as yet unclassified' stamp: 'ValeriaTiffenberg 11/13/2013 19:01'!
inicializar: aTrans1 con: aTrans2

	trans1  := aTrans1.
	trans2 := aTrans2 .! !

TransCompuesto subclass: #TransCondicion
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransCondicion class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 19:33'!
transformador1: aTrans1 transformador2: aTrans2 condicion: aBlock

|a|
a := TransCondicion new.
a inicializar: aTrans1 con: aTrans2 condicion: aBlock.
^a.! !

!TransCondicion methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 19:34'!
inicializar: aTrans1 con: aTrans2 condicion: aBlock

	trans1  := aTrans1.
	trans2 := aTrans2.
	block := aBlock.! !

!TransCondicion methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 19:37'!
transformar: aObject 

	| opt |
	opt := block value: aObject.
	^ opt
		ifTrue: [ trans1 transformar: aObject ] 
		ifFalse: [ trans2 transformar: aObject ].! !

TransCompuesto subclass: #TransSecuencial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransSecuencial class methodsFor: 'as yet unclassified' stamp: 'ValeriaTiffenberg 11/9/2013 19:41'!
transformador1: aTransf transformador2: anotherTransf 

|a|
a := TransSecuencial new.
a inicializar: aTransf con: anotherTransf .
^a.! !

!TransSecuencial methodsFor: 'as yet unclassified' stamp: 'ValeriaTiffenberg 11/13/2013 18:53'!
transformar: anObject

	| partialResult |
	partialResult := trans1 transformar: anObject.
	^ trans2 transformar: partialResult.! !

Transformador subclass: #TransIdentidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransIdentidad methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 17:39'!
transformar: aObject 

	       ^ aObject.! !

Transformador subclass: #TransSubstring
	instanceVariableNames: 'original transformado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PLP-TP3'!

!TransSubstring class methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:26'!
original: aChar transformado:bChar 

|a|
a := TransSubstring new.
a inicializar: aChar con: bChar.
^a.! !

!TransSubstring methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:25'!
inicializar: aChar con: bChar

	original := aChar.
	transformado := bChar.! !

!TransSubstring methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 18:25'!
transformar: aObject 

	   ^ aObject copyReplaceAll: original with: transformado.! !

!Transformador methodsFor: 'as yet unclassified' stamp: 'ManuelGimenez 10/29/2013 22:44'!
comoListaEquivalente
	self notYetImplemented .! !

!Transformador methodsFor: 'as yet unclassified' stamp: 'ValeriaTiffenberg 11/9/2013 22:24'!
transform: aObject
	^self transformar: aObject.! !

!Transformador methodsFor: 'as yet unclassified' stamp: 'Nicolas 11/9/2013 17:38'!
transformar: unObjeto
	self transformar .! !
